<?php
	$config = array(
		"Host" => isset($_GET['Host']) ? $_GET['Host'] : "",
		"WebPort" => isset($_GET['WebPort']) ? $_GET['WebPort'] : "",
		"WebUser" => isset($_GET['WebUser']) ? $_GET['WebUser'] : "",
		"WebPassword" => isset($_GET['WebPassword']) ? $_GET['WebPassword'] : "",
		"WebTimeout" => 10000
	);
	
	$result = array();
	
	switch ($_GET['do'])
	{
		case "getMovieList":
			$result = array("movies" => getMovieList());
			break;
			
		case "playMovie":
			$location = $_GET['location'];
			$result = array("result" => playMovie($location));
			break;
	}
	
	echo "{}&& ".json_encode($result);
	
	function sendXBMCCommand ($command)
	{
		global $config;
		
		$result = @Sys_GetURLContentEx('http://'.$config['Host'].':'.$config['WebPort'].'/xbmcCmds/xbmcHttp?command='.rawurlencode($command), array("AuthUser"=>$config['WebUser'],"AuthPass"=>$config['WebPassword'],"Timeout"=>$config['WebTimeout']));

		return $result;
	}
	
	function getMovieList ()
	{
		$query = "select movie.idMovie,movie.c00,movie.c10,movie.c05,movie.c07,movie.c11,movie.c14,streamdetails.iVideoWidth as iVideoWidth,files.strFileName as strFileName,path.strPath as strPath from movie left join streamdetails on streamdetails.idFile=movie.idFile join files on files.idFile=movie.idFile join path on path.idPath=files.idPath where streamdetails.iStreamType=0 group by streamdetails.idFile";
		$content = sendXBMCCommand("queryvideodatabase(".$query.")");

		if ($content === false)
		{
			return array("error" => "Keine Verbindung zu XBMC möglich!");
		}
		
		$movies = array();

		preg_match_all("|<field>(.*)</field>|U", $content, $fields);
		
		for ($i = 0; $i < count($fields[1]); $i = $i + 10)
		{
			$resolution = "SD";
			switch ($fields[1][$i + 7])
			{
				case 1920: $resolution = 1080; break;
				case 1280: $resolution = 720; break;
			}

			$movies[] = array(
				"id" => $fields[1][$i + 0],
				"title" => $fields[1][$i + 1],
				"sortTitle" => ($fields[1][$i + 2] != "") ? $fields[1][$i + 2] : $fields[1][$i + 1],
				"rating" => (float)$fields[1][$i + 3],
				"year" => $fields[1][$i + 4],
				"duration" => $fields[1][$i + 5],
				"genre" => $fields[1][$i + 6],
				"resolution" => $resolution,
				"file" => $fields[1][$i + 8],
				"path" => $fields[1][$i + 9]
			);
		}

		return $movies;
	}
	
	function playMovie ($location)
	{
		global $url, $user, $pwd;
		
		$location = str_replace("\\\\", "\\", $location);
		$content = sendXBMCCommand("PlayFile(".$location.";1)");
		
		return $content;
	}
?>